#!/usr/bin/perl

################################################################################
#     Beomdori's Web Link v2.0
#
#     Programmer : BeomGyu, Lee
#     E-Mail     : cadeau@orgio.net
#     Homepage   : http://beomdori.x-y.net
#
################################################################################

require "./config.cgi";
################################################################################
$gLockFlag = "N";
$gLockStat = "N";

umask(000);
&parseArgument;

sub parseArgument {
    local($buffer,$data,$name,$value);
    local(@datum);

    if($ENV{'REQUEST_METHOD'} eq "GET") {
        $buffer = $ENV{'QUERY_STRING'};
    }
    else {
        read(STDIN,$buffer,$ENV{'CONTENT_LENGTH'});
    }

    @datum = split(/&/,$buffer);
    foreach $data (@datum) {
        ($name,$value) = split(/=/,$data);
        $value =~ tr/+/ /;
        $value =~ s/%([a-fA-F0-9]{2})/pack("C",hex($1))/eg;

        $FORM{$name} = $value;
    }
    
    if($FORM{'db'}) {
        $gBaseDIR = "$gBaseDIR/$FORM{'db'}";
        $gNumFile = "$FORM{'db'}_num.cgi";
        $gCfgFile = "$FORM{'db'}_cfg.cgi";
        $gPwdFile = "$FORM{'db'}_pwd.cgi";
        $gDatFile = "$FORM{'db'}_dat.cgi";
    }
    else {
        &HTMLHeader;
        print "<center><br><font color=$gTextColor><b>ũϴ </b></font>\n";
        print "<br><br><hr noshade width=400>\n";
        print "<font color=black>$gCGI_Link<font color=red>?db=DB</font></font></center><br>\n";
        print "<hr noshade width=400><p></center>\n";
        &HTMLFooter;
    }
    
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        close(HANDLE);
        &selectAction;
    }
    else {
        &GET_COOKIE;    	        
        if($COOKIE{'ROOTADMIN'} eq $gSupervisor_Password) {
            &selectAction;
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=400><br>\n";
            print "<center><font color=red><b>ڸ DB   ֽϴ.</b></font></center><br>\n";
            print "<hr noshade width=400><p>\n";
            &HTMLFooter;
        }
    }
}

sub selectAction {
    &getNumber;
    &getEnvVar;

    unless($FORM{'action'}) {
        $FORM{'action'} = "r";
    }
    
    &GET_COOKIE;
    
    # ȸ 
    if($gUserType eq "type_member") {

         #  ȯ漳 ޴
         if($FORM{'action'} eq "admin_login") {
            if($COOKIE{'ROOTADMIN'} eq $gSupervisor_Password) {
                  &showConfigForm;         		
            }
            else {
                 &showAdminLogin;
            }           	
         }
         elsif($FORM{'action'} eq "show_config_form") {
                &checkAdminPassword;
                &showConfigForm;
         }
         elsif($FORM{'action'} eq "config") {
                &updateEnvVar;
         }
         # αǾ  α 
         elsif( !-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi" ) {
               &checkMember;           
         }
         # Ÿ 밡 ɵ
         else {         
             if($FORM{'action'} eq "r") {	
	&readData;
             } 
             elsif($FORM{'action'} eq "show_input_form") {
                    &checkAdminPassword;
	    &showInputForm;
             }
             elsif($FORM{'action'} eq "show_user_input_form") {
                    if($gUserUp eq "YES") {
                      &showUserInputForm;
                    }
             }
             elsif($FORM{'action'} eq "write") {
    	&writeData;
             } 
             elsif($FORM{'action'} eq "delete") {
                    &checkUserPassword;
	    &deleteData;
             } 
             elsif($FORM{'action'} eq "show_update_form") {
                    &checkUserPassword;
	    &showUpdateForm;
             } 
             elsif($FORM{'action'} eq "update") {
    	    &updateData;
             } 
             elsif($FORM{'action'} eq "users_login") {
                    &showUsersLogin;
             }
             elsif($FORM{'action'} eq "search") {
                    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
	       &searchDataForWebLink;
                    }
                    elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
           	           &searchDataForLinkList;
                     }
             }
             else {
                 exit;
             }
         }
    }
    # Ϲ 
    else {
         if($FORM{'action'} eq "r") {	
	&readData;
         } 
         elsif($FORM{'action'} eq "show_input_form") {
                &checkAdminPassword;
	&showInputForm;
         }
         elsif($FORM{'action'} eq "show_user_input_form") {
                if($gUserUp eq "YES") {
                  &showUserInputForm;
                }
         }
         elsif($FORM{'action'} eq "write") {
	&writeData;
         } 
         elsif($FORM{'action'} eq "delete") {
                &checkUserPassword;
	&deleteData;
        } 
        elsif($FORM{'action'} eq "login") {
                 &checkMember;
        }        
         elsif($FORM{'action'} eq "show_update_form") {
                 &checkUserPassword;
	&showUpdateForm;
         } 
         elsif($FORM{'action'} eq "update") {
	&updateData;
         } 
         elsif($FORM{'action'} eq "users_login") {
                &showUsersLogin;
         }
         elsif($FORM{'action'} eq "admin_login") {
            if($COOKIE{'ROOTADMIN'} eq $gSupervisor_Password) {
                  &showConfigForm;         		
            }
            else {
                 &showAdminLogin;
            }           	
         }
         elsif($FORM{'action'} eq "show_config_form") {
                &checkAdminPassword;
                &showConfigForm;
         }
         elsif($FORM{'action'} eq "config") {
                &updateEnvVar;
         }
         elsif($FORM{'action'} eq "search") {
                if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
	   &searchDataForWebLink;
                }
                elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
           	       &searchDataForLinkList;
                 }
         }
         else {
             exit;
         }    	
    }
}

##########################################################################
# ȸ ũ  üũ
##########################################################################
sub checkMember {	
	GET_COOKIE();
	if ( !-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi" ) {
                   print "Content-type: text/html\n\n";
                   print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's WebLink $gVerLink
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";
                   print "<html><head>\n";
                   print "<title>Beomdori's Link $gVerLink</title>\n";    
                   print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
                   print "<style type='text/css'>\n";
                   print "<!--\n";	
                   print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 0% 98%}\n";
                   print "-->\n";
                   print "</style>\n" ;    
                   print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_board.css\">\n\n";		
	   print "<script language=JavaScript>
		function IDPasswdWindow(URL) {
		  window.open(URL,'IDPasswdWindow','resizable=no,scrollbars=no,status=0,width=220, height=170');
		}
		function RegisterWindow(URL) {
	 	  window.open(URL,'RegisterWindow','resizable=no,scrollbars=no,status=0,width=500, height=560');
		}
		</script>
		</head>";

                    print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return true'>\n";
                    print "<center><br><br>\n";    
	    print "<center>
		<TABLE WIDTH=220 align=center border=0 background=$gIMG_Link/m_bg.gif>
		<TR>
		 <TD ALIGN=center colspan=3><br><b>Member Login</b><br><br></td></tr>
		 <tr><td width=80 align=right>
		<FORM ACTION=$gCGI_Login METHOD=post name=loginForm>
		<INPUT TYPE=hidden NAME=action VALUE=login_data>
		<INPUT TYPE=hidden NAME=db VALUE=$FORM{'db'}>		
		ID :&nbsp;</td>
		<td width=100 align=right> <INPUT TYPE=TEXT CLASS=INPUT NAME=MEMBER_ID size=13 style=\"IME-MODE: inactive\"></td>
                                </tr>
                                <tr><td align=right>
		Password :&nbsp;</td>
 		<td align=right><INPUT TYPE=PASSWORD CLASS=INPUT NAME=MEMBER_PW size=13></td>
                                <td width=40></td>
		</tr>
		<tr><td colspan=2 align=right>
		<INPUT TYPE=SUBMIT CLASS=INPUT VALUE=α>
		</FORM><br><br></td><td></td>
		</TABLE></DIV>";

		print "<DIV ALIGN=center>
		<TABLE WIDTH=$TABLE_WIDTH>
		<TR><TD ALIGN=CENTER>
		<br><a href=javascript:RegisterWindow('$gCGI_Member')>ȸ</a> / 
		<a href=javascript:IDPasswdWindow('$gCGI_Login?action=search_form')> ̵, нн</a>
		</TD></TR></TABLE></DIV>
                                <script language=javascript>document.loginForm.MEMBER_ID.focus();</script>
		";
                     &HTMLFooter;

	}    
}

##########################################################################
#  ȭ  ų DB 丮 ʱȭ
##########################################################################
sub getNumber {
    if(open(HANDLE,"<$gBaseDIR/$gNumFile")) {
        $gNoOfData = <HANDLE>;
        close(HANDLE);
        chop($gNoOfData);

        open(HANDLE,"<$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        if($gNoOfData != $#datum) {
            $gNoOfData = $#datum;
            &putNumber;
        }
    }
    else {
        mkdir("$gBaseDIR",0777);  
        mkdir("$gBaseDIR/data",0777);

        open(HANDLE,">$gBaseDIR/$gDatFile");
            print HANDLE "<!--EOF-->\n";
        close(HANDLE);

        $gNoOfData = "0";
        &putNumber;
    } 
}

##########################################################################
# ȣ 
##########################################################################
sub putNumber {
    open(HANDLE,">$gBaseDIR/$gNumFile");
        print HANDLE "$gNoOfData\n";
    close(HANDLE);
}

##########################################################################
# bdr_link ȯ漳 оδ.
##########################################################################
sub getEnvVar {
    local($env_list);
    local(@datum);

    if(open(HANDLE,"<$gBaseDIR/$gCfgFile")) {
        $env_list = <HANDLE>;
        close(HANDLE);
        @datum = split(/\|/,$env_list);

        $gBackColor = $datum[1];
        $gBackImgURL = $datum[2];
        $gTitleText = $datum[3];
        
        $gLinkType = $datum[12];   # ũŸ : 0. ũ    1. ũƮ
        
        $gRecPerPage = $datum[6];
        $gListNumber = $datum[7];

        $gTitleUse = $datum[11];

        $gTableWidth = $datum[5];
        $gTableTapText = $datum[13];
        $gTableTapBgcolor = $datum[27];        
        $gTableBgcolor = $datum[21];
        $gTableText = $datum[15];
        $gActiveTableColor = $datum[14];
        
        $gItem = $datum[28];
        $gItem1 = $datum[29];
        $gItem2 = $datum[30];
        $gItem3 = $datum[31];
        $gItem4 = $datum[32];
        $gItem5 = $datum[33];

        $gUserUp = $datum[34];
        $gTextColor = $datum[17];

        $gAlignType = $datum[26];        # Display Ĺ
        $gUserType = $datum[20];        # Ÿ : Ϲ type_normal, ȸ type_member
        $gBannerLocation = $datum[35];        
        
        $gTempURL2 = $datum[4];        
        $gTempColor1 = $datum[8];
        $gTempColor2 = $datum[9];
        $gTempColor3 = $datum[18];        
        $gTempColor4 = $datum[16];
        $gTempColor5 = $datum[22];
        $gTempColor6 = $datum[23];
        $gTempColor7 = $datum[10];                
        $gTempYesOrNo1 = $datum[19];        
        $gTempYesOrNo2 = $datum[24];
        $gTempYesOrNo3 = $datum[25];
        $gTempYesOrNo4 = $datum[36];        

        chop($gHomeImageURL);
    }
    else {
        # ʱ ȯ 

        $gBackColor = "#ffffff";
        $gBackImgURL = "./img/link/bg.gif";

        $gLinkType = "weblink";           # ũŸ : 0. ũ    1. ũƮ
                
        $gTitleText = "Web Link";
        $gTitleUse = "YES";

        $gTableWidth = "95%";
        $gTableTapText = "#ffffff";        
        $gTableTapBgcolor = "#494949";
        $gTableBgcolor = "#ffffff";
        $gTableText = "#000000";
        $gActiveTableColor = "#f5f5f5";
        $gTextColor = "#000000";

        $gRecPerPage = "10";
        $gListNumber = "5";
                
        $gItem = "0";
        $gItem1 = "";
        $gItem2 = "";
        $gItem3 = "";
        $gItem4 = "";
        $gItem5 = "";

        $gUserUp = "YES";              #  Ⱑ(NO )
        $gAlignType = "center";
        $gUserType = "type_normal";
        $gBannerLocation = "right";        
                
        $gTempColor1 = "#000000";
        $gTempColor2 = "#000000";        
        $gTempColor3 = "#000000";        
        $gTempColor4 = "#000000";        
        $gTempColor5 = "#000000";
        $gTempColor6 = "#000000";
        $gTempColor7 = "#000000";                
        $gTempYesOrNo1 = "YES";
        $gTempYesOrNo2 = "YES";
        $gTempYesOrNo3 = "YES";
        $gTempYesOrNo4 = "YES";
        $gTempURL2 = "";
        
        &putEnvVar;
    }
}

##########################################################################
# bdr_link ȯ漳 ȭϿ Ѵ.
########################################################################## 
sub putEnvVar {
    open(HANDLE,">$gBaseDIR/$gCfgFile");
        print HANDLE "^^|$gBackColor|$gBackImgURL|$gTitleText|$gTempURL2|$gTableWidth|$gRecPerPage|$gListNumber|$gTempColor1|$gTempColor2|$gTempColor7|$gTitleUse|$gLinkType|$gTableTapText|$gActiveTableColor|$gTableText|$gTempColor4|$gTextColor|$gTempColor3|$gTempYesOrNo1|$gUserType|$gTableBgcolor|$gTempColor11|$gTempColor12|$gTempYesOrNo2|$gTempYesOrNo3|$gAlignType|$gTableTapBgcolor|$gItem|$gItem1|$gItem2|$gItem3|$gItem4|$gItem5|$gUserUp|$gBannerLocation|$gTempYesOrNo4|\n";
    close(HANDLE);
}

##########################################################################
# Ÿ оδ. (ũ/ũƮ Ѵ.)
##########################################################################
sub readData {
    if($FORM{'p'}) {
        $gCurPage = $FORM{'p'};
    }
    else {
        $gCurPage = "1";
    }

    $gTotPage = int(($gNoOfData-1)/$gRecPerPage)+1;

    &HTMLHeader;

    print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top nowrap>\n";
    print "<tr><td width=160 align=left valign=top>";
     
    &MenuButton;
    
    print "</td>\n\n";


    print "<td width=40>&nbsp;</td>\n";
    
    print "<td valign=top><br><br>\n\n";

    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {                      # 0 : ũ
       &readIndexFileForWebLink;
       print "</td></tr></table></td></tr><tr><td colspan=3>\n";
    }
    elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {                   # 1 : ũƮ
       &readIndexFileForLinkList;
       print "</td></tr></table></td></tr><tr><td colspan=6>\n";
    }

    &FastGo;

    print "</td></tr></table>\n";
    	
    &HTMLFooter;
}

##########################################################################
# ȭ鿡 ũ Ѵ
##########################################################################
sub readIndexFileForWebLink {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@value);

    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
    
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

       print "<table border=0 width=100% cellspacing=0 cellpadding=0 valign=top>\n";    
       if($gIsMember eq "true") {
          print "<tr><td align=right><a href=$gCGI_Member?action=modify_form><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=$gCGI_Login?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a></td></tr>\n";
       }
       else {
          print "<tr><td align=right><a href=$gCGI_Member><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=$gCGI_Link?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a></td></tr>\n";
       }                         
       print "</table>\n";
       
for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
          $date_length = length($date);
          $short_date = substr($value[5],0,20);
          $value[6] =~ s/\|/&#124;/g;            
          $value[6] =~ s/(http:\/\/)([\&\w\+\-\/\=\?\.\~]+)/$url <img src=$gIMG_Link\/home.gif> <a href=\"$1$2\" target=\"_blank\">$1$2<\/a>/g;
          $value[6] =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$gIMG_Link\/mail.gif> <a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$1')\">$1<\/a>/g;

       print "<table border=0 width=100% cellspacing=0 cellpadding=0 valign=top>\n";
           
$c=$gTableBgcolor;
$t=$gTableText;
$tc=$gTableTapText;
$dc=$gTableTapBgcolor;
print "<tr><td>\n<table border=0 width=100% cellspacing=0 cellpadding=3>\n";
print "<tr bgcolor=$dc><td>&nbsp;::&nbsp;<b><a href=\"$value[8]\" target=_blank><font color=$tc>$value[2]</font></a></b></td>\n";
print "<td align=right><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/modify.gif border=0 alt=\"Modify\"></a><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/delete.gif border=0 alt=\"Delete\"></a>";
print "</td></tr>\n";
print "</table><table border=0 width=100% cellspacing=0 cellpadding=3>\n";

# ȭ  (̹ ũǾֳ  ...)
if ($value[9] eq "") {
print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\"><td colspan=2 align=left valign=top><font color=$t>$value[6]</font><br><br><br></td></tr>\n";
}
else {
  if($gBannerLocation eq "top") {
     print "<tr><td colspan=2 align=left valign=top><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0></a></td></tr>\n";
     print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
     print "<td width=100% align=left valign=top colspan=2><font color=$t>$value[6]</font><br></td>\n";
     print "</tr>\n";  	  	  	
  }
  elsif($gBannerLocation eq "bottom") {
     print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
     print "<td width=100% align=left valign=top colspan=2><font color=$t>$value[6]</font><br></td>\n";
     print "</tr>\n";  	  	  	  	
     print "<tr><td colspan=2 align=left valign=top><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0></a></td></tr>\n";     
  }
  elsif($gBannerLocation eq "left") {
     print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
     print "<td height=100 align=left valign=top width=100%><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0 align=left></a><font color=$t>$value[6]</font></td>\n";     
     print "</tr>\n";  	  	
  }
  else {
     print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
     print "<td width=100% align=left valign=top colspan=2><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0 align=right></a><font color=$t>$value[6]</font><br></td>\n";
     print "</tr>\n";  	
  }
}
print "<tr><td colspan=2 height=5 align=right><font size=1 color=aaaaaa>$value[7]</font></td></tr>\n";
print "<tr><td colspan=2 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
print "<tr><td colspan=2>&nbsp;</td></tr>\n";
print "</table>\n</td></tr>\n\n";
}
}
    unless($gNoOfData) {
        print "&nbsp;<table width=100% border=0 cellspacing=1 cellpadding=6 align=center>\n";
        print "<tr align=center><td><font color=\"red\"><b> ϵ Ʈ ϴ.</font></b></td></tr>\n";
    }
}

##########################################################################
# ȭ鿡 ũƮ Ѵ
##########################################################################
sub readIndexFileForLinkList {
    local($i,$j,$rec_color,$txt_color,$actual_number,$short_subject,$short_date,$old_date,$new_date);
    local(@datum,@value);

    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
    
    print "<table border=0  width=100% cellspacing=0 cellpadding=0 valign=top nowrap>\n";
    if($gIsMember eq "true") {
       print "<tr><td align=right><a href=$gCGI_Member?action=modify_form><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=$gCGI_Login?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a></td></tr>\n";
    }
    else {
       print "<tr><td align=right><a href=$gCGI_Member><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=$gCGI_Link?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a></td></tr>\n";
    }                      
    $c=$gTableBgcolor;
    $t=$gTableText;
    print "<tr><td><table border=0 cellspacing=0 cellpadding=0 nowrap>\n";
    print "<tr bgcolor=$gTableTapBgcolor height=20>\n";
    print "<td align=left width=100>&nbsp;&nbsp;<font color=\"$gTableTapText\"> </font></td><td align=left width=140>&nbsp;&nbsp;<font color=\"$gTableTapText\">&nbsp;&nbsp;ó</font></td>\n";
    print "<td align=left width=210>&nbsp;&nbsp;<font color=\"$gTableTapText\">E-Mail</font></td><td align=left width=380>&nbsp;&nbsp;&nbsp;&nbsp;<font color=\"$gTableTapText\">Http/Ftp/Telenet</font></td>\n";
    print "<td width=14>&nbsp;&nbsp;</td><td width=14>&nbsp;&nbsp;</td></tr>\n\n";
	
    for($i=($gCurPage-1)*$gRecPerPage+1;$i<=($gCurPage-1)*$gRecPerPage+$gRecPerPage;$i++) {
        @value = split(/\|/,$datum[$i]);    
        $actual_number = ($gNoOfData+1)-$i;

        if($actual_number > 0) {
	   $date_length = length($value[5]);
      	   $short_date = substr($value[5],0,20);

           if($value[6] eq "") { 
	     print "<tr><td colspan=6>\n";
	     print "<table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
	     print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
                     print "<td align=left width=100>$value[2]</td>\n";
   	     print "<td align=left width=140>$value[3]</td>\n";
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "<td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[4]</a></td>\n";
                     }
                     else {
                        print "<td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\">$value[4]</a></td>\n";
                     }   	     
	     print "<td align=left width=380><a href=\"$value[8]\" target=_blank>$value[8]</a></td>\n";
	     print "<td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
	     print "<td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
	     print "</tr>\n";
	   }
	   else {
	     print "<tr onmouseover=\"drc(':: Ÿ', '$value[6]<br><br>'); high(popup)\" onmouseout=\"low(popup);\"><td colspan=6>\n";
	     print " <table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
	     print "  <tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
                     print "   <td align=left width=100>$value[2]</td>\n";
   	     print "   <td align=left width=140>$value[3]</td>\n";
             	     if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
                        print "   <td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$value[4]')\">$value[4]</a></td>\n";
                     }
                     else {
                        print "   <td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?tomail=$value[4]')\">$value[4]</a></td>\n";
                     }                           	     
	     print "   <td align=left width=380><a href=\"$value[8]\" target=_blank>$value[8]</a></td>\n";
	     print "   <td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$value[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
	     print "   <td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$value[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
	     print "  </tr>\n";	   	
	   }
           print "  <tr><td colspan=6 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
           print " </table>\n";
           print "</td></tr>\n\n";
        }
    }
   
    unless($gNoOfData) {
       print "&nbsp;<table width=100% border=0 cellspacing=1 cellpadding=6 align=center>\n";
       print "<tr align=center><td><font color=\"red\"><b>No List</font></b></td></tr>\n";
    }
    print "</table>\n";
}

##########################################################################
#  
##########################################################################
sub FastGo {
       print "<table border=0 cellpadding=9 cellspacing=1 align=center valign=middle height=100><tr><td align=center>\n";
       $term = $gListNumber;
       $f = 1;
       $l = $term;
       while ($f <= $gTotPage) {
         if(($f <= $gCurPage) && ($gCurPage <= $l)) {
          $prevp = $f - 1;

          if ($prevp > 0) {
             print "<a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$prevp><img src=$gIMG_Link/y_prev.gif border=0 alt=\" \"></a>..";
          }
          
          if ($l <= $gTotPage) {
	for ($page = $f; $page <= $l; $page++) {
	      if ($page == $gCurPage) {
                         print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
	      }
                      else {
                         print "<a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$page>[$page]</a>";
                      }
               }
          }
          else {
             for ($page = $f; $page <= $gTotPage; $page++) {
	   if ($page == $gCurPage) {
                     print "<font color=$gTableText>[<font color=blue><b>$page</b></font>]</font>";
                   }
                   else {
                     print "<font color=$gTextColor><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$page>[$page]</font></a>";
                   }
            }
         }
         $nextp = $l + 1;
         
         if ($nextp <= $gTotPage) {
           print "..<a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$nextp><img src=$gIMG_Link/y_next.gif border=0 alt=\" \"></a>";
         }
     }
     
     $f = $f + $term;
     $l = $l + $term;
   }
   print "</td></tr></table>\n";
}

##########################################################################
# ȭ  ⸦ Ѵ
##########################################################################
sub MenuButton {
    print "<br><br><table width=160 border=0 cellspacing=1 cellpadding=2 align=center>\n";
    print "<tr>\n";
    print "<td align=left>\n";
    print "<table border=0 cellspacing=1 cellpadding=2 width=160 valign=top>\n";    
    print "<tr><td background=$gIMG_Link/tb_top.gif height=30 width=160>\n";    
    # ŸƲ ǥÿ
    if($gTitleUse eq "YES") {
         print "<center><b>$gTitleText</b></center>\n";
    }    
    print "</td></tr>\n";
    
    if ($gItem eq "1") {    	
        print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item1>$gItem1</a></td></tr>\n";
        print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";             
    }

    if ($gItem eq "2") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item1>$gItem1</a></td></tr>\n";
       print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item2>$gItem2</a></td></tr>\n";
       print "<tr><td width=80% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }

    if ($gItem eq "3") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item1>$gItem1</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item2>$gItem2</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item3>$gItem3</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
    }

    if ($gItem eq "4") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item1>$gItem1</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item2>$gItem2</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item3>$gItem3</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";    	
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item4>$gItem4</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }

    if ($gItem eq "5") {
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item1>$gItem1</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item2>$gItem2</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item3>$gItem3</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";    	
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item4>$gItem4</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
       print "<tr><td onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">&nbsp;&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=search&word=Item5>$gItem5</a></td></tr>\n";
       print "<tr><td width=100% height=1 bgcolor=#e3e3e3></td></tr>\n";       
    }
    
    #   or    , ü ,  
      if($gUserUp eq "YES") {
        print "<tr><td background=$gIMG_Link/tb_bottom.gif height=30 width=200 align=center>\n";
        print "<a href=$gCGI_Link?db=$FORM{'db'}&action=show_user_input_form><img src=$gIMG_Link/write.gif border=0 alt=\"Register\"></a>\n";
        print "<a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=$gIMG_Link/total_list.gif border=0 alt=\"Total List\"></a>\n";
        print "&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIMG_Link/admin.gif border=0 alt=\"Administrator Only\"></a>\n";
        print "</td></tr>\n";
        print "</table></font>\n";
      }
      else {
        print "<tr><td background=$gIMG_Link/tb_bottom.gif height=30 width=200 align=center>\n";
        print "<a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><img src=$gIMG_Link/total_list.gif border=0 alt=\"Total List\"></a>\n";
        print "&nbsp;<a href=$gCGI_Link?db=$FORM{'db'}&action=admin_login&p=$gCurPage&c=show_config_form><img src=$gIMG_Link/admin.gif border=0 alt=\"Administrator Only\"></a>\n";
        print "</td></tr>\n";
        print "</table></font>\n";
      }
          
    print "</td></tr></table>\n";
}

##########################################################################
# ⿡  ũ Ѵ
##########################################################################
sub searchDataForWebLink {
    local($data,$counter);
    local(@datum,@value);    

    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
    
    &getNumber;  
    &HTMLHeader;
    unless($FORM{'word'}) {
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue>˻ Է ʾҽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "<p><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
    }
    else {
        open(HANDLE,"$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        
          print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top>\n";
          print "<tr><td width=160 align=left valign=top>";
     
          &MenuButton;
    
          print "</td>\n\n";   
          
          print "<td width=40>&nbsp;</td>\n\n";   
          
          print "<td align=left valign=top>\n<table border=0 width=100% cellspacing=0 cellpadding=0>\n";
 
# ũ ̸           
         print "<tr><td height=27 valign=bottom>\n";
         print "<table border=0 width=100%><tr><td align=left><br>\n";

         if ($FORM{'word'} eq "Item1") {
            print "&nbsp;<b>:: $gItem1 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item2") {
            print "&nbsp;<b>:: $gItem2 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item3") {
            print "&nbsp;<b>:: $gItem3 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item4") {
            print "&nbsp;<b>:: $gItem4 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item5") {
            print "&nbsp;<b>:: $gItem5 ::</b>\n";
         }      
         print "</td><td align=right><br>";
         if($gIsMember eq "true") {
           print "<a href=$gCGI_Member?action=modify_form><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=$gCGI_Login?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a>\n";
         }
         else {
           print "<a href=$gCGI_Member><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=$gCGI_Link?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a>\n";
         }                                             
         print "</td></tr></table>";
         print "</td></tr>\n";
              
        $counter = 0; 
        for($i=1;$i<=$gNoOfData;$i++ ) {
            @v = split(/\|/,$datum[$i]);            
            open(HANDLE,"$gBaseDIR/data/$v[1].cgi");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/,$data);
            if($value[10] =~ /$FORM{'word'}/i) {

                &printRecordForWebLink;

                $counter++;
            }
         } 
         print "</td></tr></table></td></tr><tr><td colspan=3>\n";         
         print "</td></tr></table>\n";
    }
     print "<br><br><br><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center><br><br>\n";

        &HTMLFooter;  
}

##########################################################################
# ⿡  ũƮ Ѵ
##########################################################################
sub searchDataForLinkList {
    local($data,$counter);
    local(@datum,@value);    

    if(!-e "./members/logon/$COOKIE{'MEMBER_ID'}.cgi") {
       $gIsMember = false;	
    }
    else {
       $gIsMember = true;	
    }
    
    &getNumber;  
    &HTMLHeader;
    unless($FORM{'word'}) {
            print "<br><br><hr noshade width=80%>\n";
            print "<font color=blue>˻ Է ʾҽϴ</font>\n";
            print "<hr noshade width=80%>\n";
            print "<p><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
    }
    else {
        open(HANDLE,"$gBaseDIR/$gDatFile");
            @datum = <HANDLE>;
        close(HANDLE);
        print "<table border=0 width=$gTableWidth cellpadding=0 cellspacing=1 align=center valign=top nowrap>\n";
        print "<tr><td width=160 align=left valign=top>";
     
        &MenuButton;
    
        print "</td>\n\n";   
          
        print "<td width=40>&nbsp;</td>\n";
        
        print "<td align=left valign=top><br>\n";

# ũ ̸           
         print "<table border=0 width=100%><tr><td align=left>\n";
         
         if ($FORM{'word'} eq "Item1") {
            print "&nbsp;<b>:: $gItem1 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item2") {
            print "&nbsp;<b>:: $gItem2 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item3") {
            print "&nbsp;<b>:: $gItem3 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item4") {
            print "&nbsp;<b>:: $gItem4 ::</b>\n";
         }
         if ($FORM{'word'} eq "Item5") {
            print "&nbsp;<b>:: $gItem5 ::</b>\n";
         }
         print "</td><td align=right valign=bottom>";
         if($gIsMember eq "true") {
           print "<a href=$gCGI_Member?action=modify_form><IMG SRC=$gIMG_Link/Info.gif border=0></a> <a href=$gCGI_Login?db=$FORM{'db'}&action=logout_data2><IMG SRC=$gIMG_Link/logout.gif border=0></a>\n";
         }
         else {
           print "<a href=$gCGI_Member><IMG SRC=$gIMG_Link/register.gif border=0></a> <a href=$gCGI_Link?db=$FORM{'db'}&action=login><IMG SRC=$gIMG_Link/login.gif border=0></a>\n";
         }                  
        print "</td></tr></table>";
        print "<table border=0 cellspacing=0 cellpadding=0 nowrap>\n";
        print "<tr bgcolor=$gTableTapBgcolor height=20>\n";
        print "<td align=left width=100>&nbsp;&nbsp;<font color=\"$gTableTapText\"> </font></td><td align=left width=140>&nbsp;&nbsp;<font color=\"$gTableTapText\">&nbsp;&nbsp;ó</font></td>\n";
        print "<td align=left width=220>&nbsp;&nbsp;<font color=\"$gTableTapText\">E-Mail</font></td><td align=left width=380>&nbsp;&nbsp;&nbsp;&nbsp;<font color=\"$gTableTapText\">Http/Ftp/Telenet</font></td>\n";
        print "<td width=14>&nbsp;&nbsp;</td><td width=14>&nbsp;&nbsp;</td></tr>\n";
             
        $counter = 0; 
        for($i=1;$i<=$gNoOfData;$i++ ) {
            @v = split(/\|/,$datum[$i]);            
            open(HANDLE,"$gBaseDIR/data/$v[1].cgi");
                $data = <HANDLE>;
            close(HANDLE);

            @value = split(/\|/,$data);
            if($value[10] =~ /$FORM{'word'}/i) {

                &printRecordForLinkList;

                $counter++;
            }
         } 
       unless($gNoOfData) {
         print "&nbsp;<table width=100% border=0 cellspacing=1 cellpadding=6 align=center>\n";
         print "<tr align=center><td><font color=\"red\"><b>No List</font></b></td></tr>\n";
       }
       print "</table>\n";
    }
     print "<br><br><br><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a><br><br></center>\n";

        &HTMLFooter;  
}

##########################################################################
# ⿡  ũ ȭ鿡 Ѵ
##########################################################################
sub printRecordForWebLink {
    local($short_subject,$short_date,$actual_number,$old_date,$new_date);

    $date_length = length($v[5]);
    $short_date = substr($v[5],0,20);
         
    print "<tr><td><table border=0 cellspacing=0 cellpadding=3 width=100%>";
    $c=$gTableBgcolor;
    $t=$gTableText;
    $tc=$gTableTapText;
    $dc=$gTableTapBgcolor;
    $v[6] =~ s/\|/&#124;/g;            
    $v[6] =~ s/(http:\/\/)([\&\w\+\-\/\=\?\.\~]+)/$url <img src=$gIMG_Link\/home.gif> <a href=\"$1$2\" target=\"_blank\">$1$2<\/a>/g;
    $v[6] =~ s/([\w\-]+\@[\w\-+\.]+[\w\-]+)/$mail <img src=$gIMG_Link\/mail.gif> <a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$1')\">$1<\/a>/g;
    print "<tr bgcolor=$dc><td>&nbsp;::&nbsp;<b><a href=\"$v[8]\" target=_blank><font color=$tc>$v[2]</font></a></b></td>";
    print "<td align=right><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$v[1]><img src=$gIMG_Link/modify.gif border=0 alt=\"Modify\"></a><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$v[1]><img src=$gIMG_Link/delete.gif border=0 alt=\"Delete\"></a>\n";
    print "</td></tr>\n";
    print "</table><table border=0 width=100% cellspacing=0 cellpadding=3>\n";

    # ȭ  (̹ ũǾֳ  ...)
    if($v[9] eq "") {
        print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\"><td colspan=2 align=left valign=top><font color=$t>$v[6]</font><br><br><br></td></tr>\n";
    }
    else {
      if($gBannerLocation eq "top") {
         print "<tr><td colspan=2 align=left valign=top><a href=\"$v[8]\" target=_blank><img src=\"$v[9]\" border=0></a></td></tr>\n";
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td width=100% align=left valign=top colspan=2><font color=$t>$v[6]</font><br></td>\n";
         print "</tr>\n";  	  	  	
      }
      elsif($gBannerLocation eq "bottom") {
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td width=100% align=left valign=top colspan=2><font color=$t>$v[6]</font><br></td>\n";
         print "</tr>\n";  	  	  	  	
         print "<tr><td colspan=2 align=left valign=top><a href=\"$v[8]\" target=_blank><img src=\"$v[9]\" border=0></a></td></tr>\n";     
      }
      elsif($gBannerLocation eq "left") {
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td height=100 align=left valign=top width=100%><a href=\"$value[8]\" target=_blank><img src=\"$value[9]\" border=0 align=left></a><font color=$t>$value[6]</font></td>\n";
         print "</tr>\n";  	
      }
      else {
         print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
         print "<td width=100% align=left valign=top colspan=2><a href=\"$v[8]\" target=_blank><img src=\"$v[9]\" border=0 align=right></a><font color=$t>$v[6]</font><br></td>\n";
         print "</tr>\n";  	
      }
    }
    
    print "<tr><td colspan=2 height=5 align=right><font size=1 color=aaaaaa>$value[7]</font></td></tr>\n";
    print "<tr><td colspan=2 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
    print "<tr><td colspan=2>&nbsp;</td></tr>\n";
    print "</table></tr>\n\n";
}

##########################################################################
# ⿡  ũƮ ȭ鿡 Ѵ
##########################################################################
sub printRecordForLinkList {
    local($short_subject,$short_date,$actual_number,$old_date,$new_date);

    $date_length = length($v[5]);
    $short_date = substr($v[5],0,20);

    $c=$gTableBgcolor;
    $t=$gTableText;         

 
    # ȭ 
    if($v[6] eq "") {    
      print "<tr><td colspan=6>\n";
      print "<table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
      print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
      print "<td align=left width=100>$v[2]</td>\n";        # ̸
      print "<td align=left width=140>$v[3]</td>\n";        # ó
      if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
         print "<td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$v[4]')\">$v[4]</a></td>\n";     # E-Mail
      }
      else {
         print "<td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?tomail=$v[4]')\">$v[4]</a></td>\n";     # E-Mail
      }      
      print "<td align=left width=380><a href=\"$v[8]\"  target=\"_blank\">$v[8]</a></td>\n";
      print "<td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$v[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
      print "<td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$v[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
      print "</tr>\n";
    }
    else {
      print "<tr onmouseover=\"drc(':: Ÿ', '$v[6]<br><br>'); high(popup)\" onmouseout=\"low(popup);\"><td colspan=6>\n";
      print "<table border=0 cellspacing=0 cellpadding=1 nowrap>\n";
      print "<tr bgcolor=$c onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
      print "<td align=left width=100>$v[2]</td>\n";        # ̸
      print "<td align=left width=140>$v[3]</td>\n";        # ó
      if($COOKIE{'MEMBER_NAME'}) {    # ȸα Ǿ ȸ  
         print "<td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?fromname=$COOKIE{'MEMBER_NAME'}&frommail=$COOKIE{'MEMBER_EMAIL'}&tomail=$v[4]')\">$v[4]</a></td>\n";      # E-Mail
      }
      else {
         print "<td align=left width=220><a href=\"javascript:smail('$gCGI_Mail?tomail=$v[4]')\">$v[4]</a></td>\n";      # E-Mail
      }           
      print "<td align=left width=380><a href=\"$v[8]\" target=_blank>$v[8]</a></td>\n";
      print "<td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=show_update_form&l=$v[1]><img src=$gIMG_Link/mod.gif border=0 alt=\"Modify\"></a></td>\n";
      print "<td align=center width=14><a href=$gCGI_Link?db=$FORM{'db'}&action=users_login&p=$FORM{'p'}&c=delete&l=$v[1]><img src=$gIMG_Link/del.gif border=0 alt=\"Delete\"></a></td>\n";
      print "</tr>\n";    		    
    }

    print "<tr><td colspan=6 background=\"$gIMG_Link/dot.gif\" width=100% height=3></td></tr>\n";
    print "</table></td></tr>\n";
}

##########################################################################
# htmlӸ
##########################################################################
sub HTMLHeader {
    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Web Link $gVerLink
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";    
    print "<html>\n";
    print "<title>Beomdori's Web Link $gVerLink</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";    
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 0% 98%}\n";
    print "</style>\n" ;
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";
    print "<script language=javascript>\n";
    print "function clearField(field){ if (field.value == field.defaultValue) {  field.value = ''; } }\n";
    print "function checkField(field){ if (field.value == '') { field.value = field.defaultValue; } }\n";
    print "</script>\n\n";
    print "<SCRIPT language=JavaScript>\n";
    print "function smail(URL) {\n";
    print "window.open(URL,'smail','left=200, top=200, toolbar=no, location=no, directories=no, status=no, menubar=no, scrollbars=no, resizable=no, width=309, height=338');\n";
    print "}</SCRIPT>\n";
    print "</head>\n";    

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return true'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=1;url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor topmargin=0 oncontextmenu='return ture'><br>\n";
    }
    
    if(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
       print "<div id=\"overDiv\" style=\"position:absolute; left:0px; top:0px; z-index:1; visibility:hidden; border-style:none;\"></div>\n";
       print "<script language=\"JavaScript\" src=\"./bdr_link.js\"></script>\n";
    }    
    
    print "<br>\n";
    if(!$gAlignType) {
      print "<table width=$gTableWidth border=0 align=center><tr><td>\n";    
    }
    else {
      print "<table width=$gTableWidth border=0 align=$gAlignType><tr><td>\n";    
    }
}

##########################################################################
# html
##########################################################################
sub HTMLFooter {
    &copyright;
    print "</td></tr></table>\n";
    print "</body>\n";
    print "</html>\n";
    exit;
}

##########################################################################
# ۱
##########################################################################
sub copyright {
       print "\n<center><br><a href=\"http://beomdori.x-y.net\" target=\"_blank\"><font color=\"#444444\" size=1 face=Tahoma>Created by <font color=\"#444444\" size=1 face=Tahoma>Beomdori</font></a></font><br><br><br>\n";
}

##########################################################################
# Ű б
##########################################################################
sub GET_COOKIE {	
    if($ENV{'HTTP_COOKIE'}) {
        @cookies = split(/; /,$ENV{'HTTP_COOKIE'});
        foreach(@cookies) {
            ($name,$value) = split(/=/,$_);
            $COOKIE{$name} = $value;
        }
    }
}

##########################################################################
#  ۾ 
##########################################################################
sub showInputForm {
    local($data,$subject,$content,$name,$value);
    local(@value,@cookies);
    
    # Űб 
    &GET_COOKIE;
 
    &HTMLHeader;
    print "<form method=post name=AdminInputForm action=$gCGI_Link>\n";    
    print "<br><br><table border=0 cellspacing=0 cellpadding=0 align=center>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2>\n";    
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";

       if ($gItem eq "1") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gItem eq "2") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gItem eq "3") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";
         print "</select>\n";
         print "</td></tr>\n";
        }
    
       if ($gItem eq "4") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";
         print "<option value=Item4>$gItem4";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gItem eq "5") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";
         print "<option value=Item4>$gItem4";
         print "<option value=Item5>$gItem5";
         print "</select>\n";
         print "</td></tr>\n";
       }

       # ũŸԿ  Է ޶
       if(($gLinkType eq "0") || ($gLinkType eq "weblink")){
          print "<tr><td align=right><span class=cls><b>Homepage</b></span></td>\n";
          print "<td><input name=homepage type=text value='http://' size=40 class=text></td></tr>\n";
          print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
          print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td>\n";
          print "<td><input name=email value='' type=text size=40 class=text></td></tr>\n";        
          print "<tr><td align=right><span class=cls><b>Subject</b></span></td>\n";
          print "<td><input name=subject value='' type=text size=40 value='' class=text>\n";
          print "<input type=hidden name=html value=enable checked></td></tr>\n";
          print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment></textarea></td></tr>\n";
          print "<tr><td align=right><span class=cls><b>Banner URL</b></span></td>\n";
          print "<td><input name=banner value='' type=text size=63 class=text>\n";
          print "</td></tr>\n";
          print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
          print "</tr></table>\n";
          print "</td></tr></table>\n";
          print "</form>\n";
          print "<script language=\"javascript\">document.AdminInputForm.homepage.focus();</script>\n";          
       }
       elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
          print "<tr><td align=right><span class=cls><b>Name</b></span></td>\n";
          print "<td><input name=subject value='' type=text size=40 value='' class=text>\n";
          print "<input type=hidden name=banner value=\"$value[9]\">\n";                             # Ӽ : 
          print "</td></tr>\n";    
          print "<tr><td align=right><span class=cls><b>Phone</b></span></td>\n";
          print "<td><input name=phone value='' type=text size=40 class=text></td></tr>\n";    
          print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td>\n";
          print "<td><input name=email value='' type=text size=40 class=text></td></tr>\n";        
          print "<tr><td align=right><span class=cls><b>Homepage</b></span></td>\n";
          print "<td><input name=homepage type=text value='http://' size=40 class=text></td></tr>\n";
          print "<input type=hidden name=html value=enable checked><tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment></textarea></td></tr>\n";
          print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
          print "</tr></table>\n";
          print "</td></tr></table>\n";
          print "</form>\n";
          print "<script language=\"javascript\">document.AdminInputForm.subject.focus();</script>\n";
       }           
       
    &HTMLFooter;
}

##########################################################################
#  ۾ 
##########################################################################
sub showUserInputForm {
    local($data,$subject,$content,$name,$value);
    local(@value,@cookies);
    
    # Űб 
    &GET_COOKIE;
 
    &HTMLHeader;
    print "<form method=post  name=inputForm action=$gCGI_Link>\n";    
    print "<br><br><table border=0 cellspacing=0 cellpadding=0 align=center>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2 align=center>\n";    
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=write>\n";
    print "<input type=hidden name=p value=1>\n";
    
       if ($gItem eq "1") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";                   
       }

       if ($gItem eq "2") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gItem eq "3") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";
         print "</select>\n";
         print "</td></tr>\n";
        }
    
       if ($gItem eq "4") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";
         print "<option value=Item4>$gItem4";
         print "</select>\n";
         print "</td></tr>\n";
       }

       if ($gItem eq "5") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";
         print "<option value=Item4>$gItem4";
         print "<option value=Item5>$gItem5";
         print "</select>\n";
         print "</td></tr>\n";
       }

       # ũŸԿ  Է ޶
       if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
         print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
         print "<td><input type=password name=passwd size=20 maxlength=16 class=text></td></tr>\n";
         print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
         print "<input name=homepage type=text value='http://' size=40 class=text>\n";
         print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
         print "</td></tr>\n";         
         print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
         print "<input name=email value='' type=text size=40 class=text></td></tr>\n";                 
         print "<tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
         print "<input name=subject value='' type=text size=40 value='' class=text>\n";
         print "<input type=hidden name=html value=enable checked></td></tr>\n";
         print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment></textarea></td></tr>\n";
         print "<tr><td align=right><span class=cls><b>Banner URL</b></span></td><td>\n";
         print "<input name=banner value='' type=text size=63 class=text></td></tr>\n";
         print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
         print "</tr></table>\n";
         print "</td></tr></table>\n";
         print "</form>\n";          	
      }
      elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")){
         print "<tr><td align=right><span class=cls><b>Password</b></span></td>\n";
         print "<td><input type=password name=passwd size=20 maxlength=16 class=text></td></tr>\n";
         print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
         print "<input name=subject value='' type=text size=40 value='' class=text>\n";
         print "<input type=hidden name=banner value=\"$value[9]\">\n";                             # Ӽ :          
         print "</td></tr>\n";    
         print "<tr><td align=right><span class=cls><b>Phone</b></span></td><td>\n";
         print "<input name=phone value='' type=text size=40 class=text></td></tr>\n";        
         print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
         print "<input name=email value='' type=text size=40 class=text></td></tr>\n";                
         print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
         print "<input name=homepage type=text value='http://' size=40 class=text></td></tr>\n";
         print "<input type=hidden name=html value=enable checked><tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment></textarea></td></tr>\n";
         print "<td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
         print "</tr></table>\n";
         print "</td></tr></table>\n";
         print "</form>\n";
      }
    print "<script language=\"javascript\">document.inputForm.passwd.focus();</script>\n";               
      
    &HTMLFooter;
}

##########################################################################
# ȭϿ Է  Ѵ.
##########################################################################
sub writeData {
    &getNumber;
    &getVariable;

    &makeCryptPassword if($passwd);
    &makeNewFile;
    &appendIndexFile;
    &sendMail if($gAdminEmail);
    $gNoOfData++;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Web Link $gVerLink
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";    
    print "<html>\n";
    print "<title>Beomdori's Web Link $gVerLink</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 0% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    
    if(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
       print "<div id=\"overDiv\" style=\"position:absolute; left:0px; top:0px; z-index:1; visibility:hidden; border-style:none;\"></div>\n";
       print "<script language=\"JavaScript\" src=\"./bdr_link.js\"></script>\n";    
    }
    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
# Է  ´
##########################################################################
sub getVariable {
# ȣ	
    if($FORM{'passwd'}) {
        $passwd = "$FORM{'passwd'}";
    }
#    else {
#        $msg = "Password ݵ ּ."; 
#        Alert();
#    }
        
# 
    unless($FORM{'subject'} =~ /^\s*$/) {
        $subject = "$FORM{'subject'}";
        $subject =~ s/\r\n\r\n/<p>/g;
        $subject =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        Alert();
    }

# 
    if($FORM{'content'}) {
       $content = "$FORM{'content'}";
       $content =~ s/\r\n\r\n/<p>/g;
       $content =~ s/\r\n/<br>/g;
    }
    else {
        $msg = " ݵ ּ."; 
        Alert();
    }
        
# ̸
    if($FORM{'email'}) {
        $email = "$FORM{'email'}";
        $email =~ s/\|/&#124;/g;
    }
    else {
        $email = "";
    }
    
# Ȩ
    if($FORM{'homepage'}) {
       if($FORM{'homepage'} eq 'http://') {
       	  $homepage = "";
       }
       else {
          $homepage = "$FORM{'homepage'}";
          $homepage =~ s/\|/&#124;/g;
        }
    }
    else {
        $msg = "Ȩ ݵ ּ."; 
        Alert();
    }
    
# 
    if($FORM{'banner'}) {
      if($FORM{'banner'} eq 'URL') {
        $banner = "";
      }
      else {
        $banner = "$FORM{'banner'}";
        $banner =~ s/\|/&#124;/g;
      }
    }
    else {
        $banner = "";
    }

# ó
    if($FORM{'phone'}) {
        $phone = "$FORM{'phone'}";
        $phone =~ s/\|/&#124;/g;
    }
    else {
        $phone = "";
    }
    
#     
    if($FORM{'Items'}) {
        $Items = "$FORM{'Items'}";
      }
  
    &getDate;
    $ip = $ENV{'REMOTE_ADDR'};    
}

##########################################################################
# ¥
##########################################################################
sub getDate {     
	($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst)=localtime(time);
	$month=($mon+1);
	if($year ne "99"){
		if($year > 100){
			$year=($year-100)+2000;
		}
		elsif($year < 10){
			$year=2000+$year;	
		}
		else{
		$year="2000";
		}
        }
        else {
	   $year="1999";
        }
	if($month < 10) { $month="0$month";}
	if($mday < 10) { $mday="0$mday";}
	if($min < 10) { $min="0$min";}
	if($sec < 10) { $sec="0$sec";}
	
                $date = "$year/$month/$mday, $hour:$min:$sec"; 
                $d = "$year$month$mday";
}  

##########################################################################
# Ϻ
##########################################################################
sub sendMail {
    open(MAIL,"|$gEmailPgm -t $mail");
    print MAIL "To: $email\n";
    print MAIL "From: $gAdminEmail\n";
    print MAIL "Subject: $gEmailSubject\n";
    $gEmailContent =~ s/<p>/\n\n/g;
    $gEmailContent =~ s/<br>/\n/g;
    print MAIL "$gEmailContent";
    close(MAIL);
}

##########################################################################
# ޼
##########################################################################
sub Alert {
    print "CONTENT-TYPE:TEXT/HTML\n\n";
    print "<script>
	   window.alert('$msg');
	   history.go(-1);
	   </script>";
    exit;
}

##########################################################################
#  α δ
##########################################################################
sub showUsersLogin {
    local($command);

    if($FORM{'c'} eq "delete") {
        $command = "delete";
    }
    else {
        $command = "show_update_form";
    }
 
    &HTMLHeader;
    print "<TABLE WIDTH=220 valign=top align=center border=0 background=$gIMG_Link/m_bg.gif>\n";    
    print "<tr><td align=center valign=top>\n";        	    
    print "<form method=post name=reply action=$gCGI_Link>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=action value=$command>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    if($FORM{'c'} eq "delete") {    
       print "<center><br><b>Delete</b><br><br></center>\n";
    }
    if($FORM{'c'} eq "show_update_form") {
       print "<center><br><b>Modify</b><br><br></center>\n";    	
    }    
    print "<font color=$gTextColor>йȣ </font>\n";
    print "<input type=password name=passwd size=12 maxlength=16> \n";
    print "</td></tr>\n";
    print "<tr><td align=right valign=top>\n";        
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "delete");
    print "<input type=submit value=\" Ȯ  \">\n" if($command eq "show_update_form");
    print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";        
    print "</form>\n";
    print "<br><br><br><br></td></tr></table>\n";        
    print "<script language=\"javascript\">document.reply.passwd.focus();</script>\n";    
    &HTMLFooter;       
}

##########################################################################
#  ȣ üũѴ
##########################################################################
sub checkUserPassword {
    local($data,$crypt_code,$save_password,$crypt_password);
    local(@passwd,@set,@datum,@value);
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @passwd = split(/\|/,$data);

    open(HANDLE,"$gBaseDIR/$gPwdFile");
        $save_password = <HANDLE>;
    close(HANDLE);
    chop($save_password);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $crypt_password = crypt($FORM{'passwd'},$crypt_code);

    unless($crypt_password eq $passwd[0] || $crypt_password eq $save_password) {
        &HTMLHeader;
        print "<br><br><hr noshade width=80%>\n";
        print "<center><font color=red> йȣ ġ ʽϴ.</font></center>\n";        
        print "<hr noshade width=80%>\n";
        print "</form><p><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
        &HTMLFooter;
    } 
    
}

##########################################################################
# ϵ ȭ Ѵ
##########################################################################
sub deleteData {
    local(@datum,@value);
 
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/, $data);
        if($FORM{'l'} != $value[1]) {
            print HANDLE "$data";             
        }
    }
    close(HANDLE);

    unlink("$gBaseDIR/data/$FORM{'l'}.cgi");

    &getNumber;
    $gNoOfData--;
    &putNumber;

    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Web Link $gVerLink
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";    
    print "<html>\n";
    print "<title>Beomdori's Web Link $gVerLink</title>\n";    
    print "<meta http-equiv=\"desription\" name=\"description\" content=\"text/html; charset=KS_C_5601-1987; charset=euc-kr\">\n";        
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 0% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
# ϵ ȭ  Ʈ 
##########################################################################
sub showUpdateForm {
    local($data,$name,$value);
    local(@cookies);
    
    # Ű б
    local(@value);
    &GET_COOKIE;
 
    open(HANDLE,"$gBaseDIR/data/$FORM{'l'}.cgi");
        $data = <HANDLE>;
    close(HANDLE);
    @value = split(/\|/,$data);             

    &HTMLHeader;
    print "<form method=post  name=updateform action=$gCGI_Link>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
    print "<input type=hidden name=action value=update>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=l value=$FORM{'l'}>\n";
    print "<input type=hidden name=OldPassword value=$value[0]>\n";
    print "<br><br>\n<table border=0 cellspacing=0 cellpadding=0 align=center>\n";
    print "<tr><td>\n";

    print "<table border=0 cellspacing=1 cellpadding=2 align=center>\n";    
              
    if ($gItem eq "2") {
      if($value[10] eq "") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[10] eq "Item1") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[10] eq "Item2") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2 selected>$gItem2";
         print "</select>\n";
         print "</td></tr>\n";
      }            
    }
     
    if ($gItem eq "3") {
      if($value[10] eq "") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[10] eq "Item1") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";                  
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[10] eq "Item2") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2 selected>$gItem2";
         print "<option value=Item3>$gItem3";                  
         print "</select>\n";
         print "</td></tr>\n";
      }            
      if($value[10] eq "Item3") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3 selected>$gItem3";         
         print "</select>\n";
         print "</td></tr>\n";
      }                  
    }
    
    if ($gItem eq "4") {
      if($value[10] eq "") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[10] eq "Item1") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                           
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[10] eq "Item2") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2 selected>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }            
      if($value[10] eq "Item3") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3 selected>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }                  
      if($value[10] eq "Item4") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4 selected>$gItem4";                  
         print "</select>\n";
         print "</td></tr>\n";
      }                       
    }
         
    if ($gItem eq "5") {
      if($value[10] eq "") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";         
         print "<option value=Item5>$gItem5";                                    
         print "</select>\n";
         print "</td></tr>\n";
      }         
      if($value[10] eq "Item1") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1 selected>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";         
         print "<option value=Item5>$gItem5";                                    
         print "</select>\n";
         print "</td></tr>\n";
      }
      if($value[10] eq "Item2") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2 selected>$gItem2";
         print "<option value=Item3>$gItem3";                  
         print "<option value=Item4>$gItem4";         
         print "<option value=Item5>$gItem5";                           
         print "</select>\n";
         print "</td></tr>\n";
      }            
      if($value[10] eq "Item3") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3 selected>$gItem3";         
         print "<option value=Item4>$gItem4";         
         print "<option value=Item5>$gItem5";                           
         print "</select>\n";
         print "</td></tr>\n";
      }                  
      if($value[10] eq "Item4") {    	    	
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4 selected>$gItem4";                                    
         print "<option value=Item5>$gItem5";                  
         print "</select>\n";
         print "</td></tr>\n";
      }                       
      if($value[10] eq "Item5") {
         print "<tr><td align=right><span class=cls><b>Classification</b></span></td><td><select name=Items style=\"background-color:#ffffff;border:1 solid black\">";
         print "<option value=Item1>$gItem1";
         print "<option value=Item2>$gItem2";
         print "<option value=Item3>$gItem3";         
         print "<option value=Item4>$gItem4";                  
         print "<option value=Item5 selected>$gItem5";                                             
         print "</select>\n";
         print "</td></tr>\n";
      }                             
    }

    #  ŸԿ  Է ޶.
    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
       print "<input type=hidden name=passwd size=20 maxlength=16 class=text value=\"$value[0]\">\n";
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value=\"$value[8]\" size=40 type=text class=text></td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input type=hidden name=phone value=\"$value[3]\">\n";                             # Ӽ : ó
       print "<input name=email value=\"$value[4]\" type=text size=40 class=text></td></tr>\n";               
       print "</td></tr><tr><td align=right><span class=cls><b>Subject</b></span></td><td>\n";
       $value[2] =~ s/<br>/\n/g;
       $value[2] =~ s/<p>/\n\n/g;
       print "<input name=subject value=\"$value[2]\" type=text size=40 value='' class=text></td></tr>\n";
       $value[6] =~ s/<br>/\n/g;
       $value[6] =~ s/<p>/\n\n/g;       
       print "<tr><td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment>$value[6]</textarea></td>\n";    
       print "</tr><tr><td align=right><span class=cls><b>Banner URL</b></span></td><td>\n";
       print "<input name=banner value=\"$value[9]\" type=text size=63 class=text>\n";
       print "</td></tr><tr>\n";
       print "<td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.updateform.homepage.focus();</script>\n";     
     }
     elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
       print "<input type=hidden name=passwd size=20 maxlength=16 class=text value=\"$value[0]\">\n";     	
       print "<tr><td align=right><span class=cls><b>Name</b></span></td><td>\n";
       $value[2] =~ s/<br>/\n/g;
       $value[2] =~ s/<p>/\n\n/g;
       print "<input name=subject value=\"$value[2]\" type=text size=40 value='' class=text></td>\n";
       print "</tr>\n";
       print "<tr><td align=right><span class=cls><b>Phone</b></span></td><td>\n";
       print "<input name=phone value=\"$value[3]\" type=text size=40 class=text>\n";
       print "<input type=hidden name=banner value=\"$value[9]\">\n";                             # Ӽ : 
       print "</td></tr>\n";
       print "<tr><td align=right><span class=cls><b>E-Mail</b></span></td><td>\n";
       print "<input name=email value=\"$value[4]\" type=text size=40 class=text></td></tr>\n";                
       print "<tr><td align=right><span class=cls><b>Homepage</b></span></td><td>\n";
       print "<input name=homepage type=text value=\"$value[8]\" size=40 type=text class=text></td></tr>\n";
       print "<tr>\n";
       $value[6] =~ s/<br>/\n/g;
       $value[6] =~ s/<p>/\n\n/g;
       print "<td align=right valign=top><span class=cls><b>Comment</b></span></td><td><textarea name=content rows=8 cols=45 class=comment>$value[6]</textarea></td></tr>\n";    
       print "<tr><td align=center colspan=2><input type=submit value=\" Ȯ  \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"> <input type=reset value=\" Է \" class=submit onmouseover=\"this.style.backgroundColor= 'silver'\"onmouseout=\"this.style.backgroundColor=''\"></td>\n";
       print "</tr></table>\n";
       print "</td></tr></table>\n";
       print "</form>\n";
       print "<script language=\"javascript\">document.updateform.subject.focus();</script>\n";     
     }
    &HTMLFooter;       
}

##########################################################################
# йȣ ȣȭѴ
##########################################################################
sub makeCryptPassword  {
    local($crypt_code);
    local(@set);

    @set = ('a'..'z','A'..'Z','0'..'9','.','/');
    $crypt_code = "$set[9]$set[3]";
    $gCryptPassword = crypt($passwd,$crypt_code);
}

##########################################################################
#  ȭ Ѵ
##########################################################################
sub makeNewFile { 
    local(@set);

    @set = ('0'..'9'); 
    srand(time);
    $gRandomFilename = "$d$set[rand(10)]$set[rand(10)]$set[rand(10)]$set[rand(10)]";
    open(HANDLE,">$gBaseDIR/data/$gRandomFilename.cgi");
        print HANDLE "$gCryptPassword|$gRandomFilename|$subject|$phone|$email|$date|$content|$ip|$homepage|$banner|$Items||||||\n";
    close(HANDLE);
}

##########################################################################
# ȭϿ  Ѵ
##########################################################################
sub appendIndexFile {
    local($data);
    local(@datum,@point);

    &lock;
    open(HANDLE,"$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);
    
    if($FORM{'l'}) {    # 亯 ߰ 
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            @point = split(/\|/,$data);
            if($point[1] eq $FORM{'l'}) {
                $thread = $point[0] + 1;
                print HANDLE "$data";
	    print HANDLE "$thread|$gRandomFilename|$subject|$phone|$email|$date|$content|$ip|$homepage|$banner|$Items||||||\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
     }
     else {
        open(HANDLE,">$gBaseDIR/$gDatFile");
        foreach $data (@datum) {
            if($data =~ /<!--EOF-->/) {
                print HANDLE "<!--EOF-->\n";
	        print HANDLE "0|$gRandomFilename|$subject|$phone|$email|$date|$content|$ip|$homepage|$banner|$Items||||||\n";	    
            }
            else {
                print HANDLE "$data";
            }
        }
        close(HANDLE);
    }
    &unlock;
}

##########################################################################
# Ʈ  ϵ ȭ ã Ѵ
##########################################################################
sub updateData {
    local(@datum,@value);

    &getVariable;

    open(HANDLE,"<$gBaseDIR/$gDatFile");
        @datum = <HANDLE>;
    close(HANDLE);

    open(HANDLE,">$gBaseDIR/$gDatFile");
    foreach $data (@datum) {
        @value = split(/\|/,$data);
        if($FORM{'l'} eq $value[1]) {
#                                      0       |ȣ            |(̸)|ó|̸|¥        |  |ip|Ȩ       |       ||||||
            print HANDLE "$value[0]|$FORM{'l'}|$subject|$phone|$email|$date|$content|$ip|$homepage|$banner|$Items||||||\n";
        }
        else {
            print HANDLE "$data";
        }
    }
    close(HANDLE);
    open(HANDLE,">$gBaseDIR/data/$FORM{'l'}.cgi");
#                                               ȣ            |ȭϸ        |(̸)|ó|̸|¥  |       |ip|Ȩ      |      |||||||
        print HANDLE "$FORM{'OldPassword'}|$FORM{'l'}|$subject|$phone|$email|$date|$content|$ip|$homepage|$banner|$Items||||||\n";
    close(HANDLE);

    print "Content-type: text/html\n\n";
    print "
<!------------------------------------------------------------------------
     Program Name  : Beomdori's Web Link $gVerLink
     Programer     : BeomGyu Lee                
     E-Mail        : cadeau\@orgio.net          
     Homepage      : http://beomdori.x-y.net
------------------------------------------------------------------------>\n\n";    
    print "<html>\n";
    print "<title>Beomdori's Web Link $gVerLink</title>\n";    
    print "<link rel=\"stylesheet\" type=\"text/css\" href=\"./bdr_link.css\">\n";
    print "<style>\n" ;
    print " BODY {background:url(\"$gBackImgURL\") $gBackColor fixed no-repeat 0% 98%}\n";
    print "</style>\n" ;    
    print "<script language=\"JavaScript\">\n";
    print "function nextWin()\n";
    print "{location = \"$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\"}\n";
    print "</script>\n";

    if($gDelayTime == 0) {
       $gBackColor = "#ffffff" unless($gBackColor);
       print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }
    else {
        print "<meta http-equiv=refresh content=2;url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}>\n";
        $gBackColor = "#ffffff" unless($gBackColor);
        print "<body bgcolor=$gBackColor oncontextmenu='return false'>\n";
    }

    print "<meta http-equiv=refresh content=\"0;  url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";

    print "</body></html>\n";
}

##########################################################################
#  α
##########################################################################
sub showAdminLogin {
    &HTMLHeader;
    unless(open(HANDLE,"$gBaseDIR/$gPwdFile")) {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Link/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";    	
        print "<br><form action=$gCGI_Link name=passwdconfig>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n";    
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=new>\n";
        print "<b> йȣ </b><br><br>\n";
        print "<table border=0 width=150>\n";
        print "<tr><td width=50 align=left>йȣ</td><td align=left><input type=password name=newpasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50 align=left>  </td><td align=left><input type=password name=repasswd size=12 maxlength=16></td></tr>\n";
        print "<tr><td width=50></td><td align=left><input type=submit value=\" Ȯ \"></td></tr>\n";
        print "</table>\n";
        print "</font></form>\n";
        print "<br></td></tr></table>\n";                    
        print "<script language=\"javascript\">document.passwdconfig.newpasswd.focus();</script>\n";                
    }
    else {
        print "<table width=220 valign=top align=center border=0 background=$gIMG_Link/m_bg.gif>\n";
        print "<tr><td align=center valign=top>\n";    	
        print "<br><form method=post name=config action=$gCGI_Link>\n";
        print "<input type=hidden name=db value=$FORM{'db'}>\n"; 
        print "<input type=hidden name=action value=$FORM{'c'}>\n";
        print "<input type=hidden name=p value=$FORM{'p'}>\n";
        print "<input type=hidden name=ps value=old>\n";
        print "<b>Config/Write</b><br><br>\n";      
        print "<input type=radio name=action value=$FORM{'c'} checked style=\"background-color:#ffffff;border:1 solid white\"> ȯ漳 &nbsp;\n";
        print "<input type=radio name=action value=show_input_form style=\"background-color:#ffffff;border:1 solid white\"> ۾\n";
        print "<br><br>йȣ&nbsp;<input type=password name=oldpasswd size=12 maxlength=16>\n";
        print "</td></tr>\n";
        print "<tr><td align=right valign=top>\n";       
        print " <input type=submit value=\" Ȯ \">\n";
        print "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";                    
        print "</form>\n";
        print "<br></td></tr></table>\n";                            
        print "<script language=\"javascript\">document.config.oldpasswd.focus();</script>\n";        
    }
    &HTMLFooter;
    close(HANDLE);
}

##########################################################################
#  ȣüũ
########################################################################## 
sub checkAdminPassword {
    local($crypt_code,$save_password,$old_password,$new_password);
    local(@set);
    
    # йȣ űԷ
    if($FORM{'ps'} eq "new") {  
        if($FORM{'newpasswd'} eq $FORM{'repasswd'}) {
            if($FORM{'newpasswd'} ne "") {
                @set = ('a'..'z','A'..'Z','0'..'9','.','/');
                $crypt_code = "$set[9]$set[3]";
                $save_password = crypt($FORM{'newpasswd'},$crypt_code);
                open(HANDLE,">$gBaseDIR/$gPwdFile");
                    print HANDLE "$save_password\n";
	                close(HANDLE);
            }
            else {
                &HTMLHeader;
                print "<br><br><hr noshade width=80%>\n";
                print "<center><font color=blue> йȣ Է ʾҽϴ</font></center>\n";
                print "<hr noshade width=80%>\n";
                print "</form><p><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";

                &HTMLFooter;
            }
        }
        else {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<center><font color=blue> йȣ ġ ʽϴ</font></center>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
            &HTMLFooter;
        } 
    } 

    # йȣ Ȯ
    else { 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
            print "<br><br><hr noshade width=80%>\n";
            print "<center><font color=blue> йȣ ġ ʽϴ</font></center>\n";
            print "<hr noshade width=80%>\n";
            print "</form><p><center><a href=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}><font color=$gTextColor>ư</font></a></center>\n";
            &HTMLFooter;
        }
    }
}

##########################################################################
# ȣ üũ
##########################################################################
sub checkConfigPassword {
    local($crypt_code,$save_password,$old_password,$new_password,$cur_passwd);
    local(@set);
 
        open(HANDLE,"<$gBaseDIR/$gPwdFile");
            $save_password = <HANDLE>;
        close(HANDLE);
        chop($save_password);

        @set = ('a'..'z','A'..'Z','0'..'9','.','/');
        $crypt_code = "$set[9]$set[3]";
        $old_password = crypt($FORM{'oldpasswd'},$crypt_code);

        unless($old_password eq $save_password) {
            &HTMLHeader;
	        print "<br>| <a href=\"javascript:history.back()\">ڷ</a> |\n";
            print "<br><br><hr noshade width=80%>\n";
            print "<center><font color=blue>ȯ漳 Ȯ   йȣ ġ ʽϴ.</font></center>\n";
            print "<hr noshade width=80%>\n";
            &HTMLFooter;
        }
}


##########################################################################
# ڿ  ȯ漳
##########################################################################
sub showConfigForm {
    &HTMLHeader;
    print "<br><br><b><font color=\"3355cc\"><center>Configuration For <b>$gSupervisor_HomeName</b></center></font></b><br><br>\n";
    print "<table border=0 width=500 align=$gAlignType><tr><td>\n";
    print "<form action=$gCGI_Link>\n";
    print "<input type=hidden name=db value=$FORM{'db'}>\n";
    print "<input type=hidden name=action value=config>\n";
    print "<input type=hidden name=p value=$FORM{'p'}>\n";
    print "<input type=hidden name=ps value=new>\n";

# DB 
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: DB :: </b></td></tr>\n";
    print "<tr><td align=left>User Type</td>\n";
    print "<td align=right><select name=UserType>\n";
    if($gUserType eq "type_member") {
        print "<option value=type_normal>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        print "<option value=type_member selected>ȸ&nbsp;&nbsp;&nbsp;";
    }
    else {
        print "<option value=type_normal selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        print "<option value=type_member>ȸ&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";    
    print "<tr><td align=left>Link Type</td>\n";
    print "<td align=right><select name=LinkType>\n";
    if(($gLinkType eq "0") || ($gLinkType eq "weblink")) {
        print "<option value=weblink selected>&nbsp;&nbsp;&nbsp;ũ";
        print "<option value=linklist>ũƮ";
    }
    elsif(($gLinkType eq "1") || ($gLinkType eq "linklist")) {
        print "<option value=weblink>&nbsp;&nbsp;&nbsp;ũ";
        print "<option value=linklist selected>ũƮ";
    }
    print "</select></td></tr>\n";
    print "</table><br>\n";

# йȣ     
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: йȣ  :: </b></td></tr>\n";
    print "<tr align=right><td align=left>йȣ</td><td align=right><input type=password name=newpasswd size=12 maxlength=16>\n";
    print "<tr align=right><td align=left>Է</td><td align=right><input type=password name=repasswd size=12 maxlength=16>\n";
    print "</td></tr></table><br>\n";

######
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";
    print "<tr><td align=left>Background Color</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gBackColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=BackColor value=\"$gBackColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Text Color</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTextColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TextColor value=\"$gTextColor\" size=10></td></tr>\n";
    print "<tr><td align=left>Background URL</td><td align=right><input type=text name=BackImgURL value=\"$gBackImgURL\" size=40></td></tr>\n";
    print "</table><br>\n";

###ŸƲ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b>:: Title ::</td></tr>\n";
    print "<tr><td align=left>Title</td><td align=right><select name=TitleUse></font>";
    if($gTitleUse eq "YES") {
        print "<option value=YES selected>̱";
        print "<option value=NO>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    else {
        print "<option value=YES>̱";
        print "<option value=NO selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";
    print "<tr><td align=left>ŸƲ Text</td><td align=right><input type=text name=TitleText value=\"$gTitleText\" size=12 maxlength=7 class=ad></td></tr>\n";
    print "</table><br>\n";

### ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> ::   :: </b></td></tr>\n";

    print "<tr><td align=left>̺  Bgcolor</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTapBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TitleBack value=\"$gTableTapBgcolor\" size=10></td></tr>\n";
    print "<tr><td align=left>̺  Text</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTapText\">&nbsp;&nbsp;</td></tr></table><input type=text name=TitleColor value=\"$gTableTapText\" size=10></td></tr>\n";    
    
    print "<tr><td align=left>̺ Bgcolor</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableBgcolor\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableBgcolor value=\"$gTableBgcolor\" size=10></td></tr>\n";
    print "<tr><td align=left>̺ Text</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gTableTextr\">&nbsp;&nbsp;</td></tr></table><input type=text name=TableText value=\"$gTableText\" size=10></td></tr>\n";    
    print "<tr><td align=left>Ȱȭ ̺ Color</td><td align=right><table border=1 bgcolor=black bordercolor=\"#cccccc\"  bordercolorlight=\"black\" bordercolordark=\"white\" cellspacing=0 cellpadding=0 align=right valign=top><tr><td bgcolor=\"$gActiveTableColor\">&nbsp;&nbsp;</td></tr></table><input type=text name=ActiveTableColor value=\"$gActiveTableColor\" size=10></td></tr>\n";
    print "</table><br>\n";

###Display ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: Display  :: </b></td></tr>\n";
    print "<tr><td align=left> </td><td align=right><select name=UserUp></font>";
    if($gUserUp eq "YES") {
        print "<option value=YES selected>";
        print "<option value=NO>Ұ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    else {
        print "<option value=YES>";
        print "<option value=NO selected>Ұ&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    print "</select></td></tr>\n";    
    
    print "<tr><td align=left>Ĺ</td><td align=right><select name=AlignType>\n";
    if($gAlignType eq "left") {
        print "<option value=left selected>Left";
        print "<option value=center>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    elsif($gAlignType eq "center" || $gAlignType eq "") {
        print "<option value=left>Left";
        print "<option value=center selected>Center";
        print "<option value=right>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gAlignType eq "right") {
        print "<option value=left>Left";
        print "<option value=center>Center";
        print "<option value=right selected>Right&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }    
    print "</select></td></tr>\n";        
    
    print "<tr><td align=left>ġ</td><td align=right><select name=BannerLocation>\n";
    if($gBannerLocation eq "top") {
        print "<option value=top selected>";
        print "<option value=bottom>Ʒ";
        print "<option value=left>";
        print "<option value=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }
    elsif($gBannerLocation eq "bottom") {
        print "<option value=top>";
        print "<option value=bottom selected>Ʒ";
        print "<option value=left>";
        print "<option value=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }            
    elsif($gBannerLocation eq "left") {
        print "<option value=top>";
        print "<option value=bottom>Ʒ";
        print "<option value=left selected>";
        print "<option value=right>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }                
    else { # 
        print "<option value=top>";
        print "<option value=bottom>Ʒ";
        print "<option value=left>";
        print "<option value=right selected>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
    }                    
    print "</select></td></tr>\n";        
        
    print "<tr><td align=left>Table Size</td><td align=right><input type=text name=TableWidth value=\"$gTableWidth\" size=12 maxlength=4></td></tr>\n";
    print "<tr><td align=left>ǥ </td><td align=right><input type=text name=RecPerPage value=\"$gRecPerPage\" size=12 maxlength=2></td></tr>\n";
    print "<tr><td align=left>Ʈ  </td><td align=right><input type=text name=ListNumber value=\"$gListNumber\" size=12 maxlength=2></td></tr>\n";
    print "</table><br>\n";

###ٷΰ з ###
    print "<table border=0 width=100% cellpadding=2 cellspacing=1 onMouseOver=this.style.backgroundColor=\"$gActiveTableColor\" onMouseOut=this.style.backgroundColor=\"\">\n";
    print "<tr align=left><td colspan=2><b> :: з  :: </b></td></tr>\n";
    print "<tr><td align=left>з  (0 ̸ ǥþ)</td><td align=right><input type=text name=Item value=\"$gItem\" size=12 maxlength=1></td></tr>\n";
    print "<tr><td align=left>з ׸ 1</td><td align=right><input type=text name=Item1 value=\"$gItem1\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 2</td><td align=right><input type=text name=Item2 value=\"$gItem2\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 3</td><td align=right><input type=text name=Item3 value=\"$gItem3\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 4</td><td align=right><input type=text name=Item4 value=\"$gItem4\" size=12 maxlength=10></td></tr>\n";
    print "<tr><td align=left>з ׸ 5</td><td align=right><input type=text name=Item5 value=\"$gItem5\" size=12 maxlength=10></td></tr>\n";
    print "</table><br>\n";

    print "<p align=center>\n";
    print "<input type=submit value=\" Ȯ  \">\n";
    print "</form>\n";
    print "</tr></td></table>\n";

    &HTMLFooter;
}

##########################################################################
# ȯ漳 ƮѴ
##########################################################################
sub updateEnvVar {
    &checkAdminPassword if($FORM{'newpasswd'} || $FORM{'repassword'});

    $gLinkType = $FORM{'LinkType'};
    $gBackColor = $FORM{'BackColor'};
    $gTextColor = $FORM{'TextColor'};
    $gBackImgURL = $FORM{'BackImgURL'};
    $gTitleText = $FORM{'TitleText'};
    $gTableText = $FORM{'TableText'};
    $gTableWidth = $FORM{'TableWidth'};         
    $gRecPerPage = $FORM{'RecPerPage'} if($FORM{'RecPerPage'} >= 1);
    $gListNumber = $FORM{'ListNumber'};
    $gTableTapText = $FORM{'TitleColor'};
    $gActiveTableColor = $FORM{'ActiveTableColor'};
    $gTitleUse = $FORM{'TitleUse'};
    $gAlignType = $FORM{'AlignType'};
    $gTableTapBgcolor = $FORM{'TitleBack'};
    $gItem = $FORM{'Item'};
    $gItem1 = $FORM{'Item1'};
    $gItem2 = $FORM{'Item2'};
    $gItem3 = $FORM{'Item3'};
    $gItem4 = $FORM{'Item4'};
    $gItem5 = $FORM{'Item5'};
    $gUserUp = $FORM{'UserUp'};
    $gUserType = $FORM{'UserType'};
    $gTableBgcolor = $FORM{'TableBgcolor'};
    $gBannerLocation = $FORM{'BannerLocation'};
            
    $gTempColor1 = $FORM{'TempColor1'};
    $gTempColor2 = $FORM{'TempColor2'};
    $gTempColor3 = $FORM{'TempColor3'};    
    $gTempColor4 = $FORM{'TempColor4'};    
    $gTempColor7 = $FORM{'TempColor7'};
    $gTempColor11 = $FORM{'TempColor11'};
    $gTempColor12 = $FORM{'TempColor12'};       
    $gTempYesOrNo2 = $FORM{'TempYesOrNo2'};
    $gTempYesOrNo3 = $FORM{'TempYesOrNo3'};
    $gTempYesOrNo4 = $FORM{'TempYesOrNo4'};
    $gTempYesOrNo1 = $FORM{'TempYesOrNo1'};
    $gTempURL2 = $FORM{'TempURL2'} if($FORM{'TempURL2'} =~ /^http:\/\// || $FORM{'TempURL2'} eq "");
        
    &putEnvVar;
    $gCurPage = $FORM{'p'};

    print "Content-type: text/html\n\n";
    print "<html>\n";
    print "<meta http-equiv=refresh content=\"0;url=$gCGI_Link?db=$FORM{'db'}&action=r&p=$FORM{'p'}\">\n";
    print "</html>\n";
}

sub lock {
    local($LockFile) = "$gBaseDIR/lock.txt";
    local($EndTime) = time+45;

    while(-e $LockFile && time < $EndTime) {}
    open(LOCK,">$LockFile");
    chmod 0666,$LockFile;

    if($gLockFlag eq 'Y') {
        flock(LOCK,2);
    }
    $gLockStat = 'Y';
}    

sub unlock {
    local($LockFile) = "$gBaseDIR/lock.txt";

    if($gLockStat eq 'Y') {
        if($gLockFlag eq 'Y') {
            flock(LOCK,8); 
        }
        close(LOCK);
        if(-e $LockFile) { 
            unlink($LockFile);
        }
        $gLockStat = 'N'; 
    }
}

#ũ
#value0 = 0
#value1 = ȭ
#value2 = ̸/
#value3 = ó
#value4 = ̸
#value5 = ð
#value6 = 
#value7 = IP
#value8 = Ȩ
#value9 = 
#value10 = 
#value11 = 
#value12 = 
#valueAlignType = 
#value14 = 
#value15 = 